diff --git a/lib/Makefile.sources b/lib/Makefile.sources
index 85dc321..f8a1b92 100644
--- a/lib/Makefile.sources
+++ b/lib/Makefile.sources
@@ -12,6 +12,8 @@ libintel_tools_la_SOURCES = 	\
 	igt_aux.h		\
 	igt_gt.c		\
 	igt_gt.h		\
+	igt_stats.c		\
+	igt_stats.h		\
 	instdone.c		\
 	instdone.h		\
 	intel_batchbuffer.c	\
diff --git a/lib/igt_stats.c b/lib/igt_stats.c
new file mode 100644
index 0000000..fcf7abe
--- /dev/null
+++ b/lib/igt_stats.c
@@ -0,0 +1,56 @@
+/*
+ * Copyright © 2015 Intel Corporation
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+ * IN THE SOFTWARE.
+ *
+ */
+
+#include "igt_core.h"
+#include "igt_stats.h"
+
+void igt_stats_init(igt_stats_t *stats, unsigned int capacity)
+{
+	stats->values = calloc(capacity, sizeof(*stats->values));
+	igt_assert(stats->values);
+	stats->capacity = capacity;
+	stats->n_values = 0;
+}
+
+void igt_stats_fini(igt_stats_t *stats)
+{
+	free(stats->values);
+}
+
+void igt_stats_push(igt_stats_t *stats, uint64_t value)
+{
+	igt_assert(stats->n_values < stats->capacity);
+	stats->values[stats->n_values++] = value;
+}
+
+double igt_stats_get_average(igt_stats_t *stats)
+{
+	unsigned int i;
+	double a = 0.0;
+
+	for (i = 0; i < stats->n_values; i++)
+		a += (double)stats->values[i] / stats->n_values;
+
+	return a;
+}
diff --git a/lib/igt_stats.h b/lib/igt_stats.h
new file mode 100644
index 0000000..99dc1c9
--- /dev/null
+++ b/lib/igt_stats.h
@@ -0,0 +1,36 @@
+/*
+ * Copyright © 2015 Intel Corporation
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+ * IN THE SOFTWARE.
+ *
+ */
+
+#include <stdint.h>
+
+typedef struct {
+	uint64_t *values;
+	unsigned int capacity;
+	unsigned int n_values;
+} igt_stats_t;
+
+void igt_stats_init(igt_stats_t *stats, unsigned int capacity);
+void igt_stats_fini(igt_stats_t *stats);
+void igt_stats_push(igt_stats_t *stats, uint64_t value);
+double igt_stats_get_average(igt_stats_t *stats);
diff --git a/lib/tests/.gitignore b/lib/tests/.gitignore
index a745a23..5b6b3c4 100644
--- a/lib/tests/.gitignore
+++ b/lib/tests/.gitignore
@@ -7,4 +7,5 @@ igt_no_exit_list_only
 igt_no_subtest
 igt_simple_test_subtests
 igt_simulation
+igt_stats
 igt_timeout
diff --git a/lib/tests/Makefile.sources b/lib/tests/Makefile.sources
index 10e0617..7521228 100644
--- a/lib/tests/Makefile.sources
+++ b/lib/tests/Makefile.sources
@@ -6,6 +6,7 @@ check_PROGRAMS = \
 	igt_no_subtest \
 	igt_simulation \
 	igt_simple_test_subtests \
+	igt_stats \
 	igt_timeout \
 	igt_invalid_subtest_name \
 	$(NULL)
diff --git a/lib/tests/igt_stats.c b/lib/tests/igt_stats.c
new file mode 100644
index 0000000..e75a203
--- /dev/null
+++ b/lib/tests/igt_stats.c
@@ -0,0 +1,49 @@
+/*
+ * Copyright © 2015 Intel Corporation
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+ * IN THE SOFTWARE.
+ *
+ */
+
+#include "igt_core.h"
+#include "igt_stats.h"
+
+static void test_average(void)
+{
+	igt_stats_t stats;
+	double average;
+
+	igt_stats_init(&stats, 5);
+
+	igt_stats_push(&stats, 2);
+	igt_stats_push(&stats, 4);
+	igt_stats_push(&stats, 6);
+	igt_stats_push(&stats, 8);
+	igt_stats_push(&stats, 10);
+
+	average = igt_stats_get_average(&stats);
+
+	igt_assert(average == (2 + 4 + 6 + 8 + 10) / 5.);
+}
+
+igt_simple_main
+{
+	test_average();
+}